// ChildView.h : interface of the CChildView class
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_CHILDVIEW_H__C7E7BD0A_6295_11D5_B90F_A43B385BC273__INCLUDED_)
#define AFX_CHILDVIEW_H__C7E7BD0A_6295_11D5_B90F_A43B385BC273__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "WordData.h"
#include "ColorStatic.h"

/////////////////////////////////////////////////////////////////////////////
// CChildView window

class CChildView : public CWnd
{
// Construction
public:
  

// Attributes
public:

// Operations
public:
   CChildView(); 
   	bool ConfirmExit();

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CChildView)
	protected:
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CChildView();
	bool CChildView::FindWord(CString word);

	// Generated message map functions
	CList<CString,CString&> SearchHistory;
protected:
	int VScrollPos;
	int VPageSize;
	int VyskaSlov;
	int VyskaOkna;
	int DelkaOkna;
	CString OpenFile;
	bool HasName;
	bool WasChanged;

	bool bFirstUpdate;
	CWordData CurrWord;
	CWordData PreviousWord;
	CFont NadpisFont;
	CFont TextFont;
	CFont BoldTextFont;
	CListBox SearchList;
	CMap<CString,CString&,CWordData,CWordData&> Slovnik;
	afx_msg void OnLBNSelChange();
	void UpdateTexts(CDC *adc,CWordData worddata);
	void ResetTexts(CDC *adc);
	int SaveDictionary(CString FileName);
	int LoadDictionary(CString FileName);
	//{{AFX_MSG(CChildView)
	afx_msg void OnPaint();
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	afx_msg void OnNewWord();
	afx_msg void OnSize(UINT nType, int cx, int cy);
	afx_msg void OnVScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar);
	afx_msg void OnEditWord();
	afx_msg void OnDeleteWord();
	afx_msg void OnNewDict();
	afx_msg void OnSaveDictAs();
	afx_msg void OnOpenDict();
	afx_msg void OnMergeDict();
	afx_msg void OnSaveDict();
	afx_msg void OnFindWord();
	afx_msg void OnZarad();
	afx_msg void OnTemata();
	afx_msg void OnZkouseni();
	afx_msg void OnUceni();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_CHILDVIEW_H__C7E7BD0A_6295_11D5_B90F_A43B385BC273__INCLUDED_)
  
