// MyToolBar.cpp: implementation of the MyToolBar class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "MyToolBar.h"
#include "slovnik.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

#define IDC_COMBOBOX 100

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

BEGIN_MESSAGE_MAP(MyToolBar,CToolBar)
	ON_WM_CREATE()
	ON_CBN_SELCHANGE(IDC_COMBOBOX,OnCBNSelChange)
END_MESSAGE_MAP()

int MyToolBar::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	if (CToolBar::OnCreate(lpCreateStruct)==-1)
		return -1;
 LoadToolBar(IDR_MAINFRAME);
 SetButtonInfo(0,IDC_COMBOBOX,TBBS_SEPARATOR,190);
 CRect obd;
 GetItemRect(0,&obd);
 obd.bottom=obd.top+100;
 WordEdit.Create(WS_CHILD | WS_VISIBLE | WS_BORDER | WS_VSCROLL | CBS_DROPDOWN | CBS_SORT,obd,this,IDC_COMBOBOX);
 WordEdit.LimitText(70);
 return 0;
}

void MyToolBar::UpdateCombo(CList<CString,CString&> *hst)
{
 POSITION pos;
 CString a;
 pos=hst->GetTailPosition();
 WordEdit.GetWindowText(a);
 WordEdit.ResetContent();
 WordEdit.SetWindowText(a);
 WordEdit.SetEditSel(0,-1);
 while( pos != NULL ) WordEdit.AddString(hst->GetPrev(pos));
}

afx_msg void MyToolBar::OnCBNSelChange()
{
 char Text[128]="";
 WordEdit.GetLBText(WordEdit.GetCurSel(),Text);
 ::AfxGetMainWnd()->SendMessage(WM_USER+1,0,(long)&Text);
}