// TemataDiag.cpp : implementation file
//

#include "stdafx.h"
#include "slovnik.h"
#include "TemataDiag.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// TemataDiag dialog


TemataDiag::TemataDiag(CWnd* pParent /*=NULL*/)
	: CDialog(TemataDiag::IDD, pParent)
{
 try {
 NazvyTemat.SetSize(100,3);
 ObsahTemat.SetSize(100,3);
 PoctySlov.SetSize(100,3);
 }
 catch (CMemoryException* e){
 AfxMessageBox (_T ("Chyba: Nedostatek pameti"));
 e->Delete (); // Delete the exception object.
 PostQuitMessage(666);}
 	//{{AFX_DATA_INIT(TemataDiag)
	//}}AFX_DATA_INIT
}


void TemataDiag::DoDataExchange(CDataExchange* pDX)
{
CDialog::DoDataExchange(pDX);
//{{AFX_DATA_MAP(TemataDiag)
	DDX_Control(pDX, IDC_EDIT1, m_Words);
  DDX_Control(pDX, IDC_TEMATA, m_TemataCtrl);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(TemataDiag, CDialog)
	//{{AFX_MSG_MAP(TemataDiag)
	ON_BN_CLICKED(IDC_BUTTON1, OnPridatTema)
	ON_BN_CLICKED(IDC_BUTTON2, OnOdebratTema)
	ON_NOTIFY(LVN_ENDLABELEDIT, IDC_TEMATA, OnEndlabeleditTemata)
	ON_NOTIFY(LVN_ITEMCHANGED, IDC_TEMATA, OnItemchangedTemata)
	ON_NOTIFY(LVN_BEGINLABELEDIT, IDC_TEMATA, OnBeginlabeleditTemata)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// TemataDiag message handlers

void TemataDiag::OnPridatTema() 
{
	// TODO: Add your control notification handler code here
int res;
CString str;
PocetTemat++;
str.Format("Nov Tma %d",PocetTemat);
try {
	NazvyTemat.SetAtGrow(PocetTemat-1,str);
	ObsahTemat.SetSize(100+PocetTemat);
    ObsahTemat[PocetTemat-1].SetSize(100,50);
	int wrk=0;
	PoctySlov.SetAtGrow(PocetTemat-1,wrk);
}

catch (CMemoryException* e) {
 AfxMessageBox("Nedostatek pameti");
 e->Delete();
 PostQuitMessage(666);
}
res=m_TemataCtrl.InsertItem(0,str);
m_TemataCtrl.SetItemState(0, LVIS_SELECTED | LVIS_FOCUSED,LVIS_SELECTED | LVIS_FOCUSED);
m_TemataCtrl.SetFocus();
m_TemataCtrl.EnsureVisible(0, FALSE);
m_TemataCtrl.UpdateWindow();
m_TemataCtrl.EditLabel(0);
}

BOOL TemataDiag::OnInitDialog() 
{
	CString str2;
    int k;

	CDialog::OnInitDialog();
	// TODO: Add extra initialization here
	PocetTemat=0;
	m_TemataCtrl.SetColumnWidth(0,400);
	m_Words.SetReadOnly(TRUE);
	NazvyTemat.RemoveAll();
	ObsahTemat.RemoveAll();
	PoctySlov.RemoveAll();
	FILE* tematafile;
  
	if ((tematafile=fopen("temata.txt","rt"))==NULL) {MessageBox("Nemuzu nacist soubor s tematy.");return TRUE;}
   char str[129];
   if (fgets(str,128,tematafile)==NULL) return TRUE;;
   if (str[0]!='[') {MessageBox("Chyba ve strukture souboru temata.txt");return TRUE;}
   PocetTemat++;
   str[strlen(str)-1]='\0';
   for(unsigned int i=0;i<strlen(str);i++) str[i]=str[i+1];
   str[strlen(str)-1]='\0'; 
   m_TemataCtrl.InsertItem(0,str);
   try {
   NazvyTemat.SetAtGrow(PocetTemat-1,CString(str));
   int wrk=0;
   PoctySlov.SetAtGrow(PocetTemat-1,wrk);
   ObsahTemat.SetSize(100+PocetTemat);
   ObsahTemat[PocetTemat-1].SetSize(100,50);
   }

   catch (CMemoryException* e) {
	AfxMessageBox("Nedostatek pameti");
	e->Delete();
	PostQuitMessage(666);
   }

   while (!feof(tematafile)) {
   if (fgets(str,128,tematafile)==NULL) continue;   
   str[strlen(str)-1]='\0';
   if (str[0]=='[') {PocetTemat++;
   for(unsigned int i=0;i<strlen(str);i++) str[i]=str[i+1];
   str[strlen(str)-1]='\0'; 
   m_TemataCtrl.InsertItem(0,str);
   try {
   NazvyTemat.SetAtGrow(PocetTemat-1,CString(str));
   int wrk=0;
   PoctySlov.SetAtGrow(PocetTemat-1,wrk);
   ObsahTemat.SetSize(100+PocetTemat);
   ObsahTemat[PocetTemat-1].SetSize(100,50);
   }

   catch (CMemoryException* e) {
	AfxMessageBox("Nedostatek pameti");
	e->Delete();
	PostQuitMessage(666);
   }

   } else {
	PoctySlov[PocetTemat-1]++;
	ObsahTemat[PocetTemat-1].SetAtGrow(PoctySlov[PocetTemat-1]-1,str);
   }
   }
   fclose(tematafile);

   	m_Words.SetReadOnly(FALSE);
	m_Words.SetWindowText("");
   m_TemataCtrl.SetItemState(0, LVIS_SELECTED | LVIS_FOCUSED,LVIS_SELECTED | LVIS_FOCUSED);
   m_TemataCtrl.EnsureVisible(0, FALSE);
   m_TemataCtrl.UpdateWindow();
    OznacenyTema=m_TemataCtrl.GetItemText(0,0);
    for(k=0;k<PocetTemat;k++) {
	if (NazvyTemat[k]==OznacenyTema) break;}
    if (k!=PocetTemat) {

	for(int j=0;j<PoctySlov[0];j++) {
    str2+=ObsahTemat[k][j]; 
	if(j!=PoctySlov[k]-1) str2+="\r\n";
	}
	m_Words.SetWindowText(str2);
    }
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}


void TemataDiag::OnOdebratTema() 
{
// TODO: Add your control notification handler code here
POSITION pos;
CString str,str2;
int i;

pos=m_TemataCtrl.GetFirstSelectedItemPosition();
if (pos!=NULL) {
int index=m_TemataCtrl.GetNextSelectedItem(pos);
str2=m_TemataCtrl.GetItemText(index,0);
for(i=0;i<PocetTemat;i++) if (NazvyTemat[i]==OznacenyTema) break;
SmazTema(i);
m_TemataCtrl.DeleteItem(index);
if (index>0) {
m_Words.SetReadOnly(FALSE);
m_Words.SetWindowText("");
OznacenyTema=m_TemataCtrl.GetItemText(index-1,0);
for(i=0;i<PocetTemat;i++) {
   if (NazvyTemat[i]==OznacenyTema) break;}
    if (i!=PocetTemat) {
	for(int j=0;j<PoctySlov[i];j++) {
    str+=ObsahTemat[i][j]; 
	if(j!=PoctySlov[i]-1) str+="\r\n";
	}
	}
	m_Words.SetWindowText(str);
m_TemataCtrl.SetItemState(index-1, LVIS_SELECTED | LVIS_FOCUSED,LVIS_SELECTED | LVIS_FOCUSED);
m_TemataCtrl.SetFocus();
m_TemataCtrl.EnsureVisible(index-1, FALSE);
m_TemataCtrl.UpdateWindow();

} else {
	m_Words.SetReadOnly(FALSE);
	m_Words.SetWindowText("");
    OznacenyTema=m_TemataCtrl.GetItemText(0,0);
    for(i=0;i<PocetTemat;i++) {
		CString abc=NazvyTemat[i];
		if (NazvyTemat[i]==OznacenyTema) break;}
    if (i!=PocetTemat) {
	for(int j=0;j<PoctySlov[i];j++) {
    str+=ObsahTemat[i][j]; 
	if(j!=PoctySlov[i]-1) str+="\r\n";
	}
	}
	m_Words.SetWindowText(str);
m_TemataCtrl.SetItemState(0, LVIS_SELECTED | LVIS_FOCUSED,LVIS_SELECTED | LVIS_FOCUSED);
m_TemataCtrl.SetFocus();
m_TemataCtrl.EnsureVisible(0, FALSE);
m_TemataCtrl.UpdateWindow();

}
if (m_TemataCtrl.GetItemCount()==0) m_Words.SetReadOnly(TRUE);
}
}

void TemataDiag::OnOK() 
{
	// TODO: Add extra validation here
int i=0,j=0;
int Preskoceny;

for(i=0,Preskoceny=0;i<PocetTemat;i++) {
		CString str2=NazvyTemat[i];
		if (NazvyTemat[i]==OznacenyTema) break;}
    if (i<PocetTemat) {
	PoctySlov[i]=0;
	for(int j=0;j<m_Words.GetLineCount();j++) {
	char stri[128];
	int x=m_Words.GetLine(j,stri);
	stri[x]='\0';
	if (strcmp(stri,"")==0) {Preskoceny++;continue;}
	ObsahTemat[i].SetAtGrow(j-Preskoceny,stri);
	PoctySlov[i]++;
	}
	}

FILE* tematafile;
if ((tematafile=fopen("temata.txt","wt"))==NULL) {MessageBox("Nemuzu ulozit soubor s tematy.");return;}
for(i=0;i<PocetTemat;i++) {
fprintf(tematafile,"[%s]\n",NazvyTemat[i]);
for(j=0;j<PoctySlov[i];j++) {fprintf(tematafile,"%s\n",ObsahTemat[i][j]);}
}
fclose(tematafile);
CDialog::OnOK();
}





void TemataDiag::OnEndlabeleditTemata(NMHDR* pNMHDR, LRESULT* pResult) 
{
	LV_DISPINFO* pDispInfo = (LV_DISPINFO*)pNMHDR;
	// TODO: Add your control notification handler code here
	
	if (pDispInfo->item.pszText!=NULL) {
	 for(int i=0;i<PocetTemat;i++) if (NazvyTemat[i]==EditovanyText) break;
	 for(int j=0;j<PocetTemat;j++) if (NazvyTemat[j]==pDispInfo->item.pszText) break;
	 if (j!=PocetTemat) {MessageBox("Zadane tema jiz existuje.Zvolte prosim jiny nazev.");	*pResult = 0;return;}
	 else NazvyTemat[i]=pDispInfo->item.pszText;
	}
	*pResult = 1;
}





void TemataDiag::OnItemchangedTemata(NMHDR* pNMHDR, LRESULT* pResult) 
{
	NM_LISTVIEW* pNMListView = (NM_LISTVIEW*)pNMHDR;
	int i;
	CString str;
	// TODO: Add your control notification handler code here
	
	if (pNMListView->uChanged && LVIF_STATE) 
	if (pNMListView->uNewState && LVIS_SELECTED)
	{
    for(i=0;i<PocetTemat;i++) {
		CString str2=NazvyTemat[i];
		if (NazvyTemat[i]==OznacenyTema) break;}
    if (i<PocetTemat) {
	PoctySlov[i]=0;
	for(int j=0,Preskoceny=0;j<m_Words.GetLineCount();j++) {
	char stri[128];
	int x=m_Words.GetLine(j,stri);
	stri[x]='\0';
	if (strcmp(stri,"")==0) {Preskoceny++;continue;}
	try {
	ObsahTemat[i].SetAtGrow(j-Preskoceny,stri);
	}
    catch (CMemoryException* e) {
	 AfxMessageBox("Nedostatek pameti");
	 e->Delete();
	 PostQuitMessage(666);
	}

	PoctySlov[i]++;
	}
	}
	m_Words.SetReadOnly(FALSE);
	m_Words.SetWindowText("");
    OznacenyTema=m_TemataCtrl.GetItemText(pNMListView->iItem,0);
    for(i=0;i<PocetTemat;i++) {
		CString abc=NazvyTemat[i];
		if (NazvyTemat[i]==OznacenyTema) break;}
    if (i!=PocetTemat) {
	for(int j=0;j<PoctySlov[i];j++) {
    str+=ObsahTemat[i][j]; 
	if(j!=PoctySlov[i]-1) str+="\r\n";
	}
	}
	m_Words.SetWindowText(str);
	}
	*pResult = 0;
}

void TemataDiag::OnBeginlabeleditTemata(NMHDR* pNMHDR, LRESULT* pResult) 
{
	LV_DISPINFO* pDispInfo = (LV_DISPINFO*)pNMHDR;
	// TODO: Add your control notification handler code here
	EditovanyText=m_TemataCtrl.GetItemText(pDispInfo->item.iItem,0);
	*pResult = 0;
}

void TemataDiag::SmazTema(int index)
{
for(int i=index;i<PocetTemat-1;i++)  {
 NazvyTemat[i]=NazvyTemat[i+1];
 PoctySlov[i]=PoctySlov[i+1];
 ObsahTemat[i].Copy(ObsahTemat[i+1]);
}
PocetTemat--;
}