#include "stdafx.h"
#include "WordData.h"


CWordData::CWordData()
{
 Key="";
 index=0;
 PocetVyznamu=0;
}

CWordData::CWordData(CString aKey,CArray<CString,CString&> *aVyznamy,int aPocetVyznamu,int aindex)
{
 Key=aKey;
 try {Vyznamy.Copy(*aVyznamy);}
 catch (CMemoryException* e) {
        AfxMessageBox (_T ("Chyba: Nedostatek pameti"));
        e->Delete (); // Delete the exception object.
        PostQuitMessage(666);}
 PocetVyznamu=aPocetVyznamu;
 index=aindex;
}

IMPLEMENT_SERIAL (CWordData, CObject, 1)

void CWordData::Serialize(CArchive &ar)
{
 CObject::Serialize (ar);
  if (ar.IsStoring ())
	{ar<<Key<<PocetVyznamu;
	for(int i=0;i<PocetVyznamu;i++) ar<<Vyznamy[i];
	}
  else {
	 ar>>Key>>PocetVyznamu; 
	 Vyznamy.SetSize(PocetVyznamu);
     for(int i=0;i<PocetVyznamu;i++) ar>>Vyznamy[i];
  }
}


CWordData& CWordData::operator =(const CWordData& c)
{
  Key=c.Key;
  index=c.index;
  PocetVyznamu=c.PocetVyznamu;
  try {Vyznamy.Copy(c.Vyznamy);}
  catch (CMemoryException* e) {
        AfxMessageBox (_T ("Chyba: Nedostatek pameti"));
        e->Delete (); // Delete the exception object.
        PostQuitMessage(666);}
  return *this;
}


CWordData::CWordData(CWordData &c)
{
  Key=c.Key;
  index=c.index;
  PocetVyznamu=c.PocetVyznamu;
  try {Vyznamy.Copy(c.Vyznamy);}
  catch (CMemoryException* e) {
        AfxMessageBox (_T ("Chyba: Nedostatek pameti"));
        e->Delete (); // Delete the exception object.
        PostQuitMessage(666);}

}

CString CWordData::GetFirstWord()
{
 CurrVyznam=0;
 return Vyznamy[0];
}

CString CWordData::GetNextWord()
{
 CurrVyznam++;
 if (CurrVyznam<PocetVyznamu) return Vyznamy[CurrVyznam];
    else CurrVyznam--;
return CString("");
}

bool CWordData::IsLastWord()
{
 if (CurrVyznam==PocetVyznamu-1) return true;
	 else return false;
}

int CWordData::GetWordsCount()
{
 return PocetVyznamu;
}

void CWordData::GetVyznamy(CArray<CString,CString&> *c,int *vp)
{
 *vp=PocetVyznamu; 
 try {c->Copy(Vyznamy);}
 catch (CMemoryException* e) {
        AfxMessageBox (_T ("Chyba: Nedostatek pameti"));
        e->Delete (); // Delete the exception object.
        PostQuitMessage(666);}
}

CString CWordData::GetLastWord()
{
 CurrVyznam=PocetVyznamu-1;
 return Vyznamy[CurrVyznam];
}

CString CWordData::GetPreviousWord()
{
 CurrVyznam--;
 if (CurrVyznam>=0) return Vyznamy[CurrVyznam];
  else CurrVyznam++;
 return CString("");
}

bool CWordData::IsFirstWord()
{
 if (CurrVyznam==0) return true;
	 else return false;
}

