// ZkouseniDiag.cpp : implementation file
//

#include "stdafx.h"
#include "slovnik.h"
#include "ZkouseniDiag.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// ZkouseniDiag dialog


ZkouseniDiag::ZkouseniDiag(CWnd* pParent /*=NULL*/)
	: CDialog(ZkouseniDiag::IDD, pParent)
{
 PocetHesel=0;
 nSpravne=0;
 nSpatne=0;
	//{{AFX_DATA_INIT(ZkouseniDiag)
	//}}AFX_DATA_INIT
}


void ZkouseniDiag::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(ZkouseniDiag)
	DDX_Control(pDX, IDC_EDIT1, m_Zkouska);
	DDX_Control(pDX, IDC_BUTTON5, m_Zkusit);
	DDX_Control(pDX, IDC_BUTTON4, m_Zobrazit);
	DDX_Control(pDX, IDC_BUTTON2, m_Nevim);
	DDX_Control(pDX, IDC_BUTTON1, m_Vim);
	DDX_Control(pDX, IDC_STAT, m_Statistika);
	DDX_Control(pDX, IDC_LIST2, m_Vyznamy);
	DDX_Control(pDX, IDC_LIST1, m_Hesla);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(ZkouseniDiag, CDialog)
	//{{AFX_MSG_MAP(ZkouseniDiag)
	ON_COMMAND(ID_ZKOUSENI, OnZkouseni)
	ON_BN_CLICKED(IDC_BUTTON1, OnVim)
	ON_BN_CLICKED(IDC_BUTTON2, OnNevim)
	ON_BN_CLICKED(IDC_BUTTON4, OnZobrazit)
	ON_LBN_SELCHANGE(IDC_LIST1, OnSelChangeHesla)
	ON_WM_TIMER()
	ON_BN_CLICKED(IDC_BUTTON5, OnZkusit)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// ZkouseniDiag message handlers

void ZkouseniDiag::OnZkouseni() 
{
	// TODO: Add your command handler code here
	
}

BOOL ZkouseniDiag::OnInitDialog() 
{
	CDialog::OnInitDialog();
    int i,nRandom;
	if (bNahodne) {
    srand( (unsigned)time( NULL ) );
	CArray<bool,bool&> Mem;
	Mem.SetSize(PocetHesel);
	for(i=0;i<PocetHesel;i++) Mem[i]=false;
	for(i=0;i<PocetHesel;i++) {
	nRandom=rand()%PocetHesel;
	while (Mem[nRandom]) nRandom=rand()%PocetHesel;
	Mem[nRandom]=true;
	m_Hesla.AddString(Hesla[nRandom].GetKeyWord());
	}
	} else {
	for(i=0;i<PocetHesel;i++) m_Hesla.AddString(Hesla[i].GetKeyWord());
	}
	if (m_Hesla.GetCount()!=0) {
	m_Hesla.SetCurSel(0);
	m_Vyznamy.ResetContent();
  CString text;
  m_Hesla.GetText(0,text);
  for(i=0;i<PocetHesel;i++) if (Hesla[i].GetKeyWord()==text) break;
 if (i<PocetHesel) {
 m_Vyznamy.AddString(Hesla[i].GetFirstWord());
 while(!Hesla[i].IsLastWord()) {
 m_Vyznamy.AddString(Hesla[i].GetNextWord());  
 }
 }
}
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void ZkouseniDiag::OnVim() 
{
	// TODO: Add your control notification handler code here
int i;
int index=m_Hesla.GetCurSel();
if (index!=LB_ERR) {
 m_Hesla.DeleteString(index);
 nSpravne++;
 CString str;
 str.Format("Sprvn: %d  patn: %d",nSpravne,nSpatne);
 m_Statistika.SetWindowText(str);
  if (m_Hesla.GetCount()!=0) {
 m_Hesla.SetCurSel(0);
  m_Vyznamy.ResetContent();
   CString text;
  m_Hesla.GetText(0,text);
  for(i=0;i<PocetHesel;i++) if (Hesla[i].GetKeyWord()==text) break;
 if (i<PocetHesel) {
 m_Vyznamy.AddString(Hesla[i].GetFirstWord());
 while(!Hesla[i].IsLastWord()) {
 m_Vyznamy.AddString(Hesla[i].GetNextWord());  
 }
 }
 }
}
m_Vyznamy.ShowWindow(SW_HIDE);
}

void ZkouseniDiag::OnNevim() 
{
	// TODO: Add your control notification handler code here
int index=m_Hesla.GetCurSel();
if (index!=LB_ERR) {
nSpatne++;
CString str;
str.Format("Sprvn: %d  patn: %d",nSpravne,nSpatne);
m_Statistika.SetWindowText(str);
m_Nevim.ModifyStyle(0,WS_DISABLED);
m_Vim.ModifyStyle(0,WS_DISABLED);
m_Zobrazit.ModifyStyle(0,WS_DISABLED);
m_Zkusit.ModifyStyle(0,WS_DISABLED);
Invalidate();
m_Vyznamy.ShowWindow(SW_SHOW);
SetTimer(1,Rychlost,NULL);
}
}

void ZkouseniDiag::OnZobrazit() 
{
	// TODO: Add your control notification handler code here
int index=m_Hesla.GetCurSel();
if (index!=LB_ERR) {
m_Vyznamy.ShowWindow(SW_SHOW);
}
}

void ZkouseniDiag::OnSelChangeHesla() 
{
	// TODO: Add your control notification handler code here
int index=m_Hesla.GetCurSel();
if (index!=LB_ERR) {
m_Vyznamy.ResetContent();
CString text;
m_Hesla.GetText(index,text);
for(int i=0;i<PocetHesel;i++) if (Hesla[i].GetKeyWord()==text) break;
if (i<PocetHesel) {
 m_Vyznamy.AddString(Hesla[i].GetFirstWord());
 while(!Hesla[i].IsLastWord()) {
 m_Vyznamy.AddString(Hesla[i].GetNextWord());  
 }
}
}
}

void ZkouseniDiag::OnTimer(UINT nIDEvent) 
{
int i;
m_Vyznamy.ShowWindow(SW_HIDE);
int index=m_Hesla.GetCurSel();
if (index!=LB_ERR) {
 m_Hesla.DeleteString(index);
 m_Vyznamy.ResetContent();
 if (m_Hesla.GetCount()!=0) {
 m_Hesla.SetCurSel(0);
  CString text;
  m_Hesla.GetText(0,text);
  for(i=0;i<PocetHesel;i++) if (Hesla[i].GetKeyWord()==text) break;
 if (i<PocetHesel) {
 m_Vyznamy.AddString(Hesla[i].GetFirstWord());
 while(!Hesla[i].IsLastWord()) {
 m_Vyznamy.AddString(Hesla[i].GetNextWord());  
 }
 }
}
}
m_Nevim.ModifyStyle(WS_DISABLED,0);
m_Vim.ModifyStyle(WS_DISABLED,0);
m_Zobrazit.ModifyStyle(WS_DISABLED,0);
m_Zkusit.ModifyStyle(WS_DISABLED,0);
Invalidate();
KillTimer(nIDEvent);
}

CString StripComments(CString str)
{
CString wrk="";
bool bSkipChars=false;

for(int i=0;i<str.GetLength();i++) {
	if (bSkipChars) if ((str[i]==')')) {bSkipChars=false;continue;}
	else continue;
if (str[i]=='(') {bSkipChars=true;continue;}
wrk+=str[i];
}
return wrk;
}


bool CompareWords(CString Heslo,CString Tip)
{
 bool bSkipChars=false;
 CString wrk;
 int LastIndex=-1;
 Heslo=StripComments(Heslo);
 Heslo.TrimLeft();
 Heslo.TrimRight();
 if (Heslo==Tip) return true;
 for(int i=0;i<Heslo.GetLength();i++) {
 if (Heslo[i]==',')  {wrk=Heslo.Mid(LastIndex+1,i-(LastIndex+1));
                      LastIndex=i;
                      wrk.TrimRight();
					  if (wrk==Tip) return true;
}
 }
 wrk=Heslo.Mid(LastIndex+1,Heslo.GetLength()-LastIndex-1);
 wrk.TrimRight();
 if (wrk==Tip) return true;
 return false;
}

void ZkouseniDiag::OnZkusit() 
{
	// TODO: Add your control notification handler code here
int i;
int index=m_Hesla.GetCurSel();
if (index!=LB_ERR) {
CString zkouska;
m_Zkouska.GetWindowText(zkouska);
CString str;
m_Hesla.GetText(index,str);
for(i=0;i<PocetHesel;i++) if (Hesla[i].GetKeyWord()==str) break;
 if (i<PocetHesel) {
	 if (CompareWords(Hesla[i].GetFirstWord(),zkouska)) {
	 OnVim();
	 return;}
 while(!Hesla[i].IsLastWord()) {
	 if (CompareWords(Hesla[i].GetNextWord(),zkouska)) {
		 OnVim();
		 return;}
 }
 }
OnNevim();
}
}
