// UceniDiag.cpp : implementation file
//

#include "stdafx.h"
#include "slovnik.h"
#include "UceniDiag.h"
#include "HListBox.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// UceniDiag dialog


UceniDiag::UceniDiag(CWnd* pParent /*=NULL*/)
	: CDialog(UceniDiag::IDD, pParent)
{
 PocetHesel=0;
 bSpusteno=false;
 bPaused=false;
	//{{AFX_DATA_INIT(UceniDiag)
	//}}AFX_DATA_INIT
}


void UceniDiag::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(UceniDiag)
	DDX_Control(pDX, IDC_LIST2, m_Vyznamy);
	DDX_Control(pDX, IDC_OBNOVIT, m_Obnovit);
	DDX_Control(pDX, IDC_POZASTAVIT, m_Pozastavit);
	DDX_Control(pDX, IDC_SPUSTIT, m_Spustit);
	DDX_Control(pDX, IDC_LIST1, m_Hesla);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(UceniDiag, CDialog)
	//{{AFX_MSG_MAP(UceniDiag)
	ON_LBN_SELCHANGE(IDC_LIST1, OnSelchangeList1)
	ON_BN_CLICKED(IDC_SPUSTIT, OnSpustit)
	ON_WM_TIMER()
	ON_BN_CLICKED(IDC_OBNOVIT, OnObnoviti)
	ON_BN_CLICKED(IDC_DALSI, OnDalsi)
	ON_BN_CLICKED(IDC_POZASTAVIT, OnPozastavit)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// UceniDiag message handlers

BOOL UceniDiag::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	// TODO: Add extra initialization here
 int i;
 if (bNahodne) {
 CArray<bool,bool&> Mem;
 srand( (unsigned)time( NULL ) );
 int nRandom;
 Mem.SetSize(PocetHesel);
for(i=0;i<PocetHesel;i++) Mem[i]=false;
for(i=0;i<PocetHesel;i++) {
nRandom=rand()%PocetHesel;
while (Mem[nRandom]) nRandom=rand()%PocetHesel;
Mem[nRandom]=true;
m_Hesla.AddString(Hesla[nRandom].GetKeyWord());
}
 } else {
 for(i=0;i<PocetHesel;i++) m_Hesla.AddString(Hesla[i].GetKeyWord());	
 }
 	if (m_Hesla.GetCount()!=0) {
	m_Hesla.SetCurSel(0);
	m_Vyznamy.ResetContent();
  CString text;
  m_Hesla.GetText(0,text);
  for(i=0;i<PocetHesel;i++) if (Hesla[i].GetKeyWord()==text) break;
 if (i<PocetHesel) {
 m_Vyznamy.AddString(Hesla[i].GetFirstWord());
 while(!Hesla[i].IsLastWord()) {
 m_Vyznamy.AddString(Hesla[i].GetNextWord());  
 }
 }
}
 return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void UceniDiag::OnSelchangeList1() 
{
	// TODO: Add your control notification handler code here
 m_Hesla.SetCurSel(0);
}

void UceniDiag::OnSpustit() 
{
	// TODO: Add your control notification handler code here
if (m_Hesla.GetCount()>0)
{
bSpusteno=true;
SetTimer(1,Rychlost,NULL);
m_Spustit.ModifyStyle(0,WS_DISABLED);
m_Pozastavit.ModifyStyle(WS_DISABLED,0);
m_Obnovit.ModifyStyle(0,WS_DISABLED);
Invalidate();
}
}	

void UceniDiag::OnTimer(UINT nIDEvent) 
{
	// TODO: Add your message handler code here and/or call default
int i;
m_Hesla.SetCurSel(0);
int index=m_Hesla.GetCurSel();
if (index!=LB_ERR) {
 m_Hesla.DeleteString(index);
 m_Vyznamy.ResetContent();
 if (m_Hesla.GetCount()!=0) {
 m_Hesla.SetCurSel(0);
  CString text;
  m_Hesla.GetText(0,text);
  for(i=0;i<PocetHesel;i++) if (Hesla[i].GetKeyWord()==text) break;
 if (i<PocetHesel) {
 m_Vyznamy.AddString(Hesla[i].GetFirstWord());
 while(!Hesla[i].IsLastWord()) {
 m_Vyznamy.AddString(Hesla[i].GetNextWord());  
 }
 }
}
}
if (m_Hesla.GetCount()==0) {
	KillTimer(nIDEvent);
	m_Spustit.ModifyStyle(WS_DISABLED,0);
	bSpusteno=false;
	m_Pozastavit.ModifyStyle(0,WS_DISABLED);
	m_Obnovit.ModifyStyle(WS_DISABLED,0);
	Invalidate();}
}



void UceniDiag::OnCancel()
{
 EndDialog(IDCANCEL);
}

void UceniDiag::OnObnoviti() 
{
	// TODO: Add your control notification handler code here
 m_Hesla.ResetContent();
 int i;
 if (bNahodne) {
  CArray<bool,bool&> Mem;
 srand( (unsigned)time( NULL ) );
 int nRandom;
 Mem.SetSize(PocetHesel);
for(i=0;i<PocetHesel;i++) Mem[i]=false;
for(i=0;i<PocetHesel;i++) {
nRandom=rand()%PocetHesel;
while (Mem[nRandom]) nRandom=rand()%PocetHesel;
Mem[nRandom]=true;
m_Hesla.AddString(Hesla[nRandom].GetKeyWord());
}
 } else {
 for(i=0;i<PocetHesel;i++) m_Hesla.AddString(Hesla[i].GetKeyWord());
 }
 m_Hesla.SetCurSel(0);
 if (m_Hesla.GetCount()!=0) {
 m_Vyznamy.ResetContent();
 m_Hesla.SetCurSel(0);
  CString text;
  m_Hesla.GetText(0,text);
  for(i=0;i<PocetHesel;i++) if (Hesla[i].GetKeyWord()==text) break;
 if (i<PocetHesel) {
 m_Vyznamy.AddString(Hesla[i].GetFirstWord());
 while(!Hesla[i].IsLastWord()) {
 m_Vyznamy.AddString(Hesla[i].GetNextWord());  
 }
 }
}
}

void UceniDiag::OnDalsi() 
{
	// TODO: Add your control notification handler code here
int i;
bool bRestore=false;
if (bSpusteno) {KillTimer(1);bRestore=true;}
m_Hesla.SetCurSel(0);
int index=m_Hesla.GetCurSel();
if (index!=LB_ERR) {
 m_Hesla.DeleteString(index);
 m_Vyznamy.ResetContent();
 if (m_Hesla.GetCount()!=0) {
 m_Hesla.SetCurSel(0);
  CString text;
  m_Hesla.GetText(0,text);
  for(i=0;i<PocetHesel;i++) if (Hesla[i].GetKeyWord()==text) break;
 if (i<PocetHesel) {
 m_Vyznamy.AddString(Hesla[i].GetFirstWord());
 while(!Hesla[i].IsLastWord()) {
 m_Vyznamy.AddString(Hesla[i].GetNextWord());  
 }
 }
}
if (m_Hesla.GetCount()==0) {
	m_Obnovit.ModifyStyle(WS_DISABLED,0);
	Invalidate();}
}
if (bRestore) SetTimer(1,Rychlost,NULL);
}

void UceniDiag::OnPozastavit() 
{
	// TODO: Add your control notification handler code here
	if (bSpusteno) {
	if (bPaused) {
	 bPaused=false;
	 SetTimer(1,Rychlost,NULL);
	 m_Pozastavit.SetWindowText("Pozastavit");
	} else {
	 bPaused=true;
	 KillTimer(1);
	 m_Pozastavit.SetWindowText("Pokracovat");
	}
	}
}
