// VyberTemaDiag.cpp : implementation file
//

#include "stdafx.h"
#include "slovnik.h"
#include "VyberTemaDiag.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// VyberTemaDiag dialog


VyberTemaDiag::VyberTemaDiag(CWnd* pParent /*=NULL*/)
	: CDialog(VyberTemaDiag::IDD, pParent)
{
	//{{AFX_DATA_INIT(VyberTemaDiag)
	m_Zobrazovat = -1;
	//}}AFX_DATA_INIT
}


void VyberTemaDiag::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(VyberTemaDiag)
	DDX_Control(pDX, IDC_SLIDER1, m_Rychlost);
	DDX_Control(pDX, IDC_LIST1, m_VyberTemata);
	DDX_Radio(pDX, IDC_RADIO1, m_Zobrazovat);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(VyberTemaDiag, CDialog)
	//{{AFX_MSG_MAP(VyberTemaDiag)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// VyberTemaDiag message handlers

BOOL VyberTemaDiag::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	// TODO: Add extra initialization here
	PocetHesel=0;
	m_Rychlost.SetRange(500,3500);
	m_Rychlost.SetPos(Rychlost);
	SetWindowText(Title);
	FILE* tematafile;
	char str[129];
	if ((tematafile=fopen("temata.txt","rt"))==NULL) return TRUE;
	while (!feof(tematafile)) {
	if (fgets(str,128,tematafile)==NULL) continue;
	str[strlen(str)-1]='\0';
	if (str[0]=='[') {
   for(unsigned int i=0;i<strlen(str);i++) str[i]=str[i+1];
    str[strlen(str)-1]='\0'; 
    m_VyberTemata.AddString(str);
	}
	}
	fclose(tematafile);
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void VyberTemaDiag::OnOK() 
{
	// TODO: Add extra validation here
CString wrk;
bool bCtemeHesla=false;

for(int i=0;i<m_VyberTemata.GetCount();i++) {	
	if (m_VyberTemata.GetCheck(i)==1) {
m_VyberTemata.GetText(i,wrk);
FILE* tematafile;
char str[129];
bCtemeHesla=false;
if ((tematafile=fopen("temata.txt","rt"))==NULL) {CDialog::OnOK();return;}

while (!feof(tematafile)) {
if (fgets(str,128,tematafile)==NULL) continue;
str[strlen(str)-1]='\0';
if (str[0]=='[') {
 if (bCtemeHesla) bCtemeHesla=false;
 for(unsigned int i=0;i<strlen(str);i++) str[i]=str[i+1];
 str[strlen(str)-1]='\0';
 if (strcmp(str,wrk)==0) bCtemeHesla=true;
} else {
	if (bCtemeHesla) {PocetHesel++;
	try {
	Hesla.SetAtGrow(PocetHesel-1,CString(str));
	}
	catch (CMemoryException *e) {
	AfxMessageBox("Nedostatek Pameti");
	e->Delete();
	PostQuitMessage(666);
	}
	}
}
}
fclose(tematafile);
}
}
Rychlost=m_Rychlost.GetPos();
CDialog::OnOK();
}
