#ifndef WORDDATA_H
#define WORDDATA_H 0

class CWordData: public CObject
{
DECLARE_SERIAL (CWordData)
public:
 CWordData();
 CWordData(CString aKey,CArray<CString,CString&> *aVyznamy,int aPocetVyznamu,int index);
 void Serialize (CArchive& ar);
 CWordData(CWordData& c);
 CWordData& operator=(const CWordData& c);
 CString GetKeyWord(){return Key;}
 CString GetFirstWord();
 CString GetNextWord();
 CString GetLastWord();
 CString GetPreviousWord();
 void GetVyznamy(CArray<CString,CString&> *c,int *vp);
 bool IsLastWord();
 bool IsFirstWord();
 int GetWordsCount();
private:
 int CurrVyznam;
 CString Key;
 CArray<CString,CString&> Vyznamy;
 int index;
 int PocetVyznamu;
};
#endif