#if !defined(AFX_ZKOUSENIDIAG_H__313E04C0_5DFF_11D6_A0E6_00304F055F26__INCLUDED_)
#define AFX_ZKOUSENIDIAG_H__313E04C0_5DFF_11D6_A0E6_00304F055F26__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// ZkouseniDiag.h : header file
//
#include "WordData.h"
#include "HListBox.h"
/////////////////////////////////////////////////////////////////////////////
// ZkouseniDiag dialog

class ZkouseniDiag : public CDialog
{
// Construction
public:
	ZkouseniDiag(CWnd* pParent = NULL);   // standard constructor
	CArray<CWordData,CWordData&> Hesla;
	int PocetHesel;
	int nSpravne,nSpatne;
	int Rychlost;
	bool bNahodne;
// Dialog Data
	//{{AFX_DATA(ZkouseniDiag)
	enum { IDD = IDD_ZKOUSENI };
	CEdit	m_Zkouska;
	CButton	m_Zkusit;
	CButton	m_Zobrazit;
	CButton	m_Nevim;
	CButton	m_Vim;
	CStatic	m_Statistika;
	CHListBox	m_Vyznamy;
	CListBox	m_Hesla;
	//}}AFX_DATA


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(ZkouseniDiag)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:

	// Generated message map functions
	//{{AFX_MSG(ZkouseniDiag)
	afx_msg void OnZkouseni();
	virtual BOOL OnInitDialog();
	afx_msg void OnVim();
	afx_msg void OnNevim();
	afx_msg void OnZobrazit();
	afx_msg void OnSelChangeHesla();
	afx_msg void OnTimer(UINT nIDEvent);
	afx_msg void OnZkusit();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_ZKOUSENIDIAG_H__313E04C0_5DFF_11D6_A0E6_00304F055F26__INCLUDED_)
